diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-promise.c b/jerry-core/ecma/builtin-objects/ecma-builtin-promise.c
index c33a573222..1b410b280d 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-promise.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-promise.c
@@ -577,10 +577,19 @@ ecma_builtin_promise_race_or_all (ecma_value_t this_arg, /**< 'this' argument */
       || ecma_get_object_type (ecma_get_object_from_value (array)) != ECMA_OBJECT_TYPE_ARRAY)
   {
     ecma_raise_type_error (ECMA_ERR_MSG ("Second argument is not an array."));
+    ecma_value_t current_error_value = JERRY_CONTEXT (error_value);
     ret = ecma_builtin_promise_reject_abrupt (capability);
-    ecma_free_value (JERRY_CONTEXT (error_value));
-    ecma_free_value (capability);
 
+    if (JERRY_CONTEXT (error_value) == current_error_value)
+    {
+      ecma_free_value (JERRY_CONTEXT (error_value));
+    }
+    else
+    {
+      ecma_free_value (current_error_value);
+    }
+
+    ecma_free_value (capability);
     return ret;
   }
 
diff --git a/tests/jerry/fail/regression-test-issue-2489.js b/tests/jerry/fail/regression-test-issue-2489.js
new file mode 100644
index 0000000000..223af7429f
--- /dev/null
+++ b/tests/jerry/fail/regression-test-issue-2489.js
@@ -0,0 +1,16 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+Object.defineProperty(Object.prototype, 0, {'get': function() { throw $ }});
+Promise.all();
